
#ifndef __TEXTVIEW_H__
#define __TEXTVIEW_H__

#include "prefs.h"

G_BEGIN_DECLS

#define TYPE_TEXTVIEW (textview_get_type ())
#define TEXTVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXTVIEW, TextView))
#define TEXTVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXTVIEW, TextViewClass))
#define IS_TEXTVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXTVIEW))
#define IS_TEXTVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXTVIEW))
#define TEXTVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXTVIEW, TextViewClass))

typedef struct _TextView TextView;
typedef struct _TextViewClass TextViewClass;

struct _TextView {
    GtkTextView	    parent_instance;
    GtkTextTag	    *tag;
};

struct _TextViewClass {
    GtkTextViewClass    parent_class;
    void		(*history_next)(RESULT *res);
};

void	    textview_open(TextView *self, RESULT *res, Prefs *prefs, gboolean clear, gint mark);
void        textview_push_message(TextView *self, gchar *msg);
void        textview_set_pixels(TextView *self, gint n);
void        textview_clear_textbuf(TextView *self);
void        textview_insert_message(TextView *self, gchar *msg, gboolean clear);
void        textview_underline_lnk(GtkWidget *widget, GdkEventMotion *event, GtkTextTag **tag_lnk);
gint        textview_button_press(GtkWidget *widget, GdkEventButton *event, gpointer data);
void	    textview_populate_popup(GtkTextView *tview, GtkMenu *menu, gpointer user_data);

GType	    textview_get_type (void);

G_END_DECLS

#if 0
struct _textview
{
    gchar           *colors[COLOR_N];
} textview;
#endif

#endif /* __TEXTVIEW_H__ */

